import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.filter.*;

public class Draw_Grid implements PlugInFilter {
	ImagePlus imp;

	public int setup(String arg, ImagePlus imp) {
		this.imp = imp;
		return DOES_8G+NO_CHANGES;
	}

	public void run(ImageProcessor ip) {
	        int x, y;

		// get width, height and the region of interest
		int w = ip.getWidth();     
		int h = ip.getHeight();    

		// create a new image with the same size and copy the pixels of the original image
		ImagePlus framed = NewImage.createByteImage ("GridResult", w, h, 1, NewImage.FILL_BLACK);
		ImageProcessor framed_ip = framed.getProcessor();
		framed_ip.copyBits(ip,0,0,Blitter.COPY);
		byte[] out_pixels = (byte[]) framed_ip.getPixels();

		for( y = 0; y < h; y += 16 )
		for( x = 0; x < w; x ++ )
		{
			out_pixels[ ( y ) * w + x ] = (byte)(255 & 0xff);
		}

		for( x = 0; x < w; x ++ )
		{
			out_pixels[ ( h - 1 ) * w + x ] = (byte)(255 & 0xff);
		}

		for( x = 0; x < w; x += 16 )
		for( y = 0; y < h; y ++ )
		{
			out_pixels[ y * w  + x ] = (byte)(255 & 0xff);
			out_pixels[ y * w + w - 1 ] = (byte)(255 & 0xff);
		}

		for( y = 0; y < h; y ++ )
		{
			out_pixels[ y * w + w - 1 ] = (byte)(255 & 0xff);
		}

		framed.show();
		framed.updateAndDraw();
	}

}
